#ifndef GOMORYHU_HPP_
#define GOMORYHU_HPP_
#include <set>
#include <map>
#include "graph.hpp"
#include "genericGraph.hpp"
using namespace std;

class GomoryHu{

public:
	GomoryHu(Graph aGraph);
	~GomoryHu(){};
	
	void solve();

protected:
	Graph myGraph;
	set< set<int>* > currentSets;
	map< set<int>* , int> setReps;
	GenericEdge **treeEdges;
	
	Graph* graphReduction(set<int>* S);	
	int collapseSet(set<int>* S, Graph *G);
	void filterSet(set<int> *S, set<int> *filterS);
	void printTree();
	void printSets(set< set<int>* > someSets);
	void printSet(set<int> aSet);
	
};

#endif /*GOMORYHU_HPP_*/
