#include <iostream>
#include <algorithm>
#include "graph.hpp"

Graph::Graph(Graph const& copy){
	int i,j;
	
	//Read number of Vertices and Edges
	numVertices = copy.numVertices;
	numEdges = copy.numEdges;
	
	//Allocate space for graph structures
	Edges = (int **)calloc(2,sizeof(int *));
	Edges[0] = (int *)calloc(numEdges,sizeof(int));
	Edges[1] = (int *)calloc(numEdges,sizeof(int));
	Adj = (int **)calloc(numVertices,sizeof(int *));
	for(i=0;i<numVertices;i++){
		Adj[i] = (int *)calloc(numEdges,sizeof(int));		
	}
	capacities = (float *)calloc(numEdges,sizeof(float));
	
	for(j=0;j<numEdges;j++){
		Edges[0][j] = copy.Edges[0][j];
		Edges[1][j] = copy.Edges[1][j];
		capacities[j] = copy.capacities[j];
		for(i=0;i<numVertices;i++){
			Adj[i][j] = copy.Adj[i][j];
		}
	}
}

/**
 * Prints data read from the input file
 */
void Graph::printData(void){
	int i,j;

	for(i=0;i<numVertices;i++){
		for(j=0;j<numEdges;j++){
			printf("%3d ",Adj[i][j]);
		}
		printf("\n");
	}
	for(i=0;i<numEdges;i++){
		printf("%f\n",capacities[i]);
	}
}

int Graph::parseFromFile(const char * filename){
	int i,s1,s2;
	
	FILE* input = fopen(filename,"r");
	
	if(input == NULL){
		return 0;
	}
	
	//Read number of Vertices and Edges
	fscanf(input, "%d\n", &(numVertices));
	fscanf(input, "%d\n", &(numEdges));
	
	//Allocate space for graph structures
	Edges = (int **)calloc(2,sizeof(int *));
	Edges[0] = (int *)calloc(numEdges,sizeof(int));
	Edges[1] = (int *)calloc(numEdges,sizeof(int));
	Adj = (int **)calloc(numVertices,sizeof(int *));
	for(i=0;i<numVertices;i++){
		Adj[i] = (int *)calloc(numEdges,sizeof(int));		
	}
	capacities = (float *)calloc(numEdges,sizeof(float));
	
	//Read graph structure
	for(i=0;i<numEdges;i++){
		fscanf(input, "%d %d %f\n", &s1, &s2, (capacities+i));
		Edges[0][i] = s1-1;
		Edges[1][i] = s2-1;
		Adj[s1-1][i] = 1;
		Adj[s2-1][i] = -1; 
	}
	
	return 1;
}

