#ifndef MAXFLOW_HPP_
#define MAXFLOW_HPP_

#include <glpk.h>

/**
 * Computes the max flow between two vertices.
 * 
 * @param numVertices. The # of vertices
 * @param numEdge. The # of edges
 * @param Adj. The arc-node matrix. (vertices-rows, edges-cols)
 * @param s. The starting vertex
 * @param t. The goal vertex
 */ 
glp_prob* maxFlow(int numVertices, int numEdges, int **Adj, float *capacities, int s, int t);

#endif /*MAXFLOW_HPP_*/
